[build-system]
requires = ["pdm-backend"]
build-backend = "pdm.backend"

[project]
name = "luucy-python"
version = "0.1.0"
description = "LUUCY Python APIs"
authors = [
  {name = "Thorben Westerhuys", email = "thorben.westerhuys@luucy.ch"},
  ]
dependencies = [
  "requests>=2.31.0",
  ]
requires-python = ">=3.8"
readme = "README.md"
license = {text = "MIT"}

[project.urls]
Homepage = "https://www.luucy.ch"
Documentation = "https://luucy.gitlab.io/sdk/luucy-python/latest"

[tool.pdm]
version = { source = "file", path = "src/luucy/__version__.py" }

[tool.pdm.dev-dependencies]
dev = [
  "pylint>=2.17.4",
  "black>=23.3.0",
  "pre-commit>=3.3.3",
  "pytest>=7.4.0",
  "pytest-watch>=4.2.0",
  "pytest-cov>=4.1.0",
  "pytest-bdd>=6.1.1",
  "commitizen>=3.5.2",
  "mkdocs-material>=9.1.18",
  "mkdocstrings[python]>=0.22.0",
  "mkdocstrings-python>=1.1.2",
  "mike>=1.1.2",
  "pylint-pytest>=1.1.2",
  ]

[tool.pylint]
max-line-length = 88
ignore-patterns = ".*test_?.*?py"
disable = [
  "W0613", # (unused-argument)
  "R0903", # (too-few-public-methods)
  "R0913"  # (too-many-arguments)
  ]

[tool.black]
line-length = 88
target-version = ['py38']

[tool.pytest.ini_options]
addopts = "--cov --cov-report xml --cov-report term-missing --cov-fail-under 80"

[tool.coverage.run]
source = ["src"]
omit = ["__version__.py"]

[tool.commitizen]
name = "cz_conventional_commits"
tag_format = "v$version"
version_files = [
  "src/luucy/__version__.py",
  ]
version_scheme = "pep440"
version_provider = "pep621"
update_changelog_on_bump = true
major_version_zero = true
